Loading...
Searching...
No Matches
Geometric Data Structures
Data Structures » Auxiliary Data Structures

## Detailed Description

This group contains geometric data structures implemented in LEMON.

- dim2::Point implements a two dimensional vector with the usual operations.
- dim2::Box can be used to determine the rectangular bounding box of a set of dim2::Point's.

## Classes

class | Point< T >
| Two dimensional vector (plain vector). More...
class | Box< T >
| Bounding box of plain vectors (points). More...
class | XMap< M >
| Map of x-coordinates of a Point-map. More...
class | ConstXMap< M >
| Constant (read only) version of XMap. More...
class | YMap< M >
| Map of y-coordinates of a Point-map. More...
class | ConstYMap< M >
| Constant (read only) version of YMap. More...
class | NormSquareMap< M >
| Map of the normSquare() of a Point-map. More...

## Files

file | dim2.h

## Functions

template<typename T>
Point< T > | makePoint (const T &x, const T &y)
| Return a Point.
template<typename T>
Point< T > | operator* (const T &u, const Point< T > &x)
| Return a vector multiplied by a scalar.
template<typename T>
std::istream & | operator>> (std::istream &is, Point< T > &z)
| Read a plain vector from a stream.
template<typename T>
std::ostream & | operator<< (std::ostream &os, const Point< T > &z)
| Write a plain vector to a stream.
template<typename T>
Point< T > | rot90 (const Point< T > &z)
| Rotate by 90 degrees.
template<typename T>
Point< T > | rot180 (const Point< T > &z)
| Rotate by 180 degrees.
template<typename T>
Point< T > | rot270 (const Point< T > &z)
| Rotate by 270 degrees.
template<typename T>
std::istream & | operator>> (std::istream &is, Box< T > &b)
| Read a box from a stream.
template<typename T>
std::ostream & | operator<< (std::ostream &os, const Box< T > &b)
| Write a box to a stream.
template<class M>
XMap< M > | xMap (M &m)
| Returns an XMap class.
template<class M>
ConstXMap< M > | xMap (const M &m)
| Returns a ConstXMap class.
template<class M>
YMap< M > | yMap (M &m)
| Returns a YMap class.
template<class M>
ConstYMap< M > | yMap (const M &m)
| Returns a ConstYMap class.
template<class M>
NormSquareMap< M > | normSquareMap (const M &m)
| Returns a NormSquareMap class.

## Function Documentation

## makePoint()

template<typename T>

Point< T > makePoint | ( | const T & | x,
|  | const T & | y )

related

Return a Point.

## operator*()

template<typename T>

Point< T > operator* | ( | const T & | u,
|  | const Point< T > & | x )

related

Return a vector multiplied by a scalar.

## operator>>() [1/2]

template<typename T>

std::istream & operator>> | ( | std::istream & | is,
|  | Point< T > & | z )

related

Read a plain vector from a stream.

## operator<<() [1/2]

template<typename T>

std::ostream & operator<< | ( | std::ostream & | os,
|  | const Point< T > & | z )

related

Write a plain vector to a stream.

## rot90()

template<typename T>

Point< T > rot90 | ( | const Point< T > & | z | ) |

related

Returns the parameter rotated by 90 degrees in positive direction.

## rot180()

template<typename T>

Point< T > rot180 | ( | const Point< T > & | z | ) |

related

Returns the parameter rotated by 180 degrees.

## rot270()

template<typename T>

Point< T > rot270 | ( | const Point< T > & | z | ) |

related

Returns the parameter rotated by 90 degrees in negative direction.

## operator>>() [2/2]

template<typename T>

std::istream & operator>> | ( | std::istream & | is,
|  | Box< T > & | b )

related

Read a box from a stream.

## operator<<() [2/2]

template<typename T>

std::ostream & operator<< | ( | std::ostream & | os,
|  | const Box< T > & | b )

related

Write a box to a stream.

## xMap() [1/2]

template<class M>

XMap< M > xMap | ( | M & | m | ) |

related

This function just returns an XMap class.

## xMap() [2/2]

template<class M>

ConstXMap< M > xMap | ( | const M & | m | ) |

related

This function just returns a ConstXMap class.

## yMap() [1/2]

template<class M>

YMap< M > yMap | ( | M & | m | ) |

related

This function just returns a YMap class.

## yMap() [2/2]

template<class M>

ConstYMap< M > yMap | ( | const M & | m | ) |

related

This function just returns a ConstYMap class.

## normSquareMap()

template<class M>

NormSquareMap< M > normSquareMap | ( | const M & | m | ) |

related

This function just returns a NormSquareMap class.